# encoding: utf-8
# license: gpl2p external

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# This file includes an external library and makes it accessible from
# ruby. This library has it's own license, which is accessible via the
# LICENSE symlink in this directory. The corresponding directory in the
# license hierarchy may contain further information about the library or
# it's license.
#
# The license this file and the software using this file are under, does
# not apply to the external library.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
Ghun::Base.relative_require_if_exists(__FILE__,'dnsjava-2.1.3.jar')

module Dns
  java_import 'org.xbill.DNS.Resolver'
  java_import 'org.xbill.DNS.ResolverListener'
  java_import 'org.xbill.DNS.A6Record'
  java_import 'org.xbill.DNS.AAAARecord'
  java_import 'org.xbill.DNS.Address'
  java_import 'org.xbill.DNS.AFSDBRecord'
  java_import 'org.xbill.DNS.ARecord'
  java_import 'org.xbill.DNS.Cache'
  java_import 'org.xbill.DNS.CERTRecord'
  java_import 'org.xbill.DNS.ClientSubnetOption'
  java_import 'org.xbill.DNS.CNAMERecord'
  java_import 'org.xbill.DNS.Compression'
  java_import 'org.xbill.DNS.Credibility'
  java_import 'org.xbill.DNS.DClass'
  java_import 'org.xbill.DNS.DHCIDRecord'
  java_import 'org.xbill.DNS.DLVRecord'
  java_import 'org.xbill.DNS.DNAMERecord'
  java_import 'org.xbill.DNS.DNSInput'
  java_import 'org.xbill.DNS.DNSKEYRecord'
  java_import 'org.xbill.DNS.DNSOutput'
  java_import 'org.xbill.DNS.DNSSEC'
  java_import 'org.xbill.DNS.DSRecord'
  java_import 'org.xbill.DNS.EDNSOption'
  java_import 'org.xbill.DNS.ExtendedFlags'
  java_import 'org.xbill.DNS.ExtendedResolver'
  java_import 'org.xbill.DNS.Flags'
  java_import 'org.xbill.DNS.Generator'
  java_import 'org.xbill.DNS.GenericEDNSOption'
  java_import 'org.xbill.DNS.GPOSRecord'
  java_import 'org.xbill.DNS.Header'
  java_import 'org.xbill.DNS.HINFORecord'
  java_import 'org.xbill.DNS.IPSECKEYRecord'
  java_import 'org.xbill.DNS.ISDNRecord'
  java_import 'org.xbill.DNS.KEYRecord'
  java_import 'org.xbill.DNS.KXRecord'
  java_import 'org.xbill.DNS.LOCRecord'
  java_import 'org.xbill.DNS.Lookup'
  java_import 'org.xbill.DNS.Master'
  java_import 'org.xbill.DNS.MBRecord'
  java_import 'org.xbill.DNS.MDRecord'
  java_import 'org.xbill.DNS.Message'
  java_import 'org.xbill.DNS.MFRecord'
  java_import 'org.xbill.DNS.MGRecord'
  java_import 'org.xbill.DNS.MINFORecord'
  java_import 'org.xbill.DNS.MRRecord'
  java_import 'org.xbill.DNS.MXRecord'
  java_import 'org.xbill.DNS.Name'
  java_import 'org.xbill.DNS.NAPTRRecord'
  java_import 'org.xbill.DNS.NSAP_PTRRecord'
  java_import 'org.xbill.DNS.NSAPRecord'
  java_import 'org.xbill.DNS.NSEC3PARAMRecord'
  java_import 'org.xbill.DNS.NSEC3Record'
  java_import 'org.xbill.DNS.NSECRecord'
  java_import 'org.xbill.DNS.NSIDOption'
  java_import 'org.xbill.DNS.NSRecord'
  java_import 'org.xbill.DNS.NULLRecord'
  java_import 'org.xbill.DNS.NXTRecord'
  java_import 'org.xbill.DNS.Opcode'
  java_import 'org.xbill.DNS.Options'
  java_import 'org.xbill.DNS.OPTRecord'
  java_import 'org.xbill.DNS.PTRRecord'
  java_import 'org.xbill.DNS.PXRecord'
  java_import 'org.xbill.DNS.Rcode'
  java_import 'org.xbill.DNS.Record'
  java_import 'org.xbill.DNS.ResolverConfig'
  java_import 'org.xbill.DNS.ReverseMap'
  java_import 'org.xbill.DNS.RPRecord'
  java_import 'org.xbill.DNS.RRset'
  java_import 'org.xbill.DNS.RRSIGRecord'
  java_import 'org.xbill.DNS.RTRecord'
  java_import 'org.xbill.DNS.Section'
  java_import 'org.xbill.DNS.Serial'
  java_import 'org.xbill.DNS.SetResponse'
  java_import 'org.xbill.DNS.SIG0'
  java_import 'org.xbill.DNS.SIGRecord'
  java_import 'org.xbill.DNS.SimpleResolver'
  java_import 'org.xbill.DNS.SOARecord'
  java_import 'org.xbill.DNS.SPFRecord'
  java_import 'org.xbill.DNS.SRVRecord'
  java_import 'org.xbill.DNS.SSHFPRecord'
  java_import 'org.xbill.DNS.TKEYRecord'
  java_import 'org.xbill.DNS.Tokenizer'
  java_import 'org.xbill.DNS.TSIG'
  java_import 'org.xbill.DNS.TSIGRecord'
  java_import 'org.xbill.DNS.TTL'
  java_import 'org.xbill.DNS.TXTRecord'
  java_import 'org.xbill.DNS.Type'
  java_import 'org.xbill.DNS.UNKRecord'
  java_import 'org.xbill.DNS.Update'
  java_import 'org.xbill.DNS.WKSRecord'
  java_import 'org.xbill.DNS.X25Record'
  java_import 'org.xbill.DNS.Zone'
  java_import 'org.xbill.DNS.ZoneTransferIn'
  java_import 'org.xbill.DNS.InvalidDClassException'
  java_import 'org.xbill.DNS.InvalidTTLException'
  java_import 'org.xbill.DNS.InvalidTypeException'
  java_import 'org.xbill.DNS.NameTooLongException'
  java_import 'org.xbill.DNS.RelativeNameException'
  java_import 'org.xbill.DNS.TextParseException'
  java_import 'org.xbill.DNS.WireParseException'
  java_import 'org.xbill.DNS.ZoneTransferException'

  module Spi
    java_import 'org.xbill.DNS.spi.DNSJavaNameService'
    java_import 'org.xbill.DNS.spi.DNSJavaNameServiceDescriptor'
  end

  module Utils
    java_import('org.xbill.DNS.utils.base16'){ |pkg,name| 'Base16' }
    java_import('org.xbill.DNS.utils.base32'){ |pkg,name| 'Base32' }
    java_import('org.xbill.DNS.utils.base64'){ |pkg,name| 'Base64' }
    java_import('org.xbill.DNS.utils.hexdump'){ |pkg,name| 'Hexdump' }
    java_import 'org.xbill.DNS.utils.HMAC'
  end
end
