# encoding: utf-8
# license: gpl2p external

### BEGIN LICENSE NOTICE
# This file is part of %LONG% (%SHORT%)
# Copyright (C) 2010 - %YEAR%
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

# This file includes an external library and makes it accessible from
# ruby. This library has it's own license, which is accessible via the
# LICENSE symlink in this directory. The corresponding directory in the
# license hierarchy may contain further information about the library or
# it's license.
#
# The license this file and the software using this file are under, does
# not apply to the external library.
### END LICENSE NOTICE

### BEGIN AUTHOR LIST
#
### END AUTHOR LIST
Ghun::Base.relative_require_if_exists(__FILE__,'jsch-0.1.51.jar')

module JSch
  java_import 'com.jcraft.jsch.Buffer'
  java_import 'com.jcraft.jsch.ChannelAgentForwarding'
  java_import 'com.jcraft.jsch.Channel'
  java_import 'com.jcraft.jsch.ChannelDirectTCPIP'
  java_import 'com.jcraft.jsch.ChannelExec'
  java_import 'com.jcraft.jsch.ChannelForwardedTCPIP'
  java_import 'com.jcraft.jsch.ChannelSession'
  java_import 'com.jcraft.jsch.ChannelSftp'
  java_import 'com.jcraft.jsch.ChannelShell'
  java_import 'com.jcraft.jsch.ChannelSubsystem'
  java_import 'com.jcraft.jsch.ChannelX11'
  java_import 'com.jcraft.jsch.Cipher'
  java_import 'com.jcraft.jsch.CipherNone'
  java_import 'com.jcraft.jsch.Compression'
  java_import 'com.jcraft.jsch.ConfigRepository'
  java_import 'com.jcraft.jsch.DH'
  java_import 'com.jcraft.jsch.DHG14'
  java_import 'com.jcraft.jsch.DHG1'
  java_import 'com.jcraft.jsch.DHGEX256'
  java_import 'com.jcraft.jsch.DHGEX'
  java_import 'com.jcraft.jsch.ForwardedTCPIPDaemon'
  java_import 'com.jcraft.jsch.GSSContext'
  java_import 'com.jcraft.jsch.HASH'
  java_import 'com.jcraft.jsch.HostKey'
  java_import 'com.jcraft.jsch.HostKeyRepository'
  java_import 'com.jcraft.jsch.Identity'
  java_import 'com.jcraft.jsch.IdentityFile'
  java_import 'com.jcraft.jsch.IdentityRepository'
  java_import 'com.jcraft.jsch.IO'
  java_import 'com.jcraft.jsch.JSchAuthCancelException'
  java_import 'com.jcraft.jsch.JSch'
  java_import 'com.jcraft.jsch.JSchException'
  java_import 'com.jcraft.jsch.JSchPartialAuthException'
  java_import 'com.jcraft.jsch.KeyExchange'
  java_import 'com.jcraft.jsch.KeyPair'
  java_import 'com.jcraft.jsch.KeyPairDSA'
  java_import 'com.jcraft.jsch.KeyPairGenDSA'
  java_import 'com.jcraft.jsch.KeyPairGenRSA'
  java_import 'com.jcraft.jsch.KeyPairPKCS8'
  java_import 'com.jcraft.jsch.KeyPairRSA'
  java_import 'com.jcraft.jsch.KnownHosts'
  java_import 'com.jcraft.jsch.LocalIdentityRepository'
  java_import 'com.jcraft.jsch.Logger'
  java_import 'com.jcraft.jsch.MAC'
  java_import 'com.jcraft.jsch.OpenSSHConfig'
  java_import 'com.jcraft.jsch.Packet'
  java_import 'com.jcraft.jsch.PBKDF'
  java_import 'com.jcraft.jsch.PortWatcher'
  java_import 'com.jcraft.jsch.Proxy'
  java_import 'com.jcraft.jsch.ProxyHTTP'
  java_import 'com.jcraft.jsch.ProxySOCKS4'
  java_import 'com.jcraft.jsch.ProxySOCKS5'
  java_import 'com.jcraft.jsch.Random'
  java_import 'com.jcraft.jsch.RequestAgentForwarding'
  java_import 'com.jcraft.jsch.Request'
  java_import 'com.jcraft.jsch.RequestEnv'
  java_import 'com.jcraft.jsch.RequestExec'
  java_import 'com.jcraft.jsch.RequestPtyReq'
  java_import 'com.jcraft.jsch.RequestSftp'
  java_import 'com.jcraft.jsch.RequestShell'
  java_import 'com.jcraft.jsch.RequestSignal'
  java_import 'com.jcraft.jsch.RequestSubsystem'
  java_import 'com.jcraft.jsch.RequestWindowChange'
  java_import 'com.jcraft.jsch.RequestX11'
  java_import 'com.jcraft.jsch.ServerSocketFactory'
  java_import 'com.jcraft.jsch.Session'
  java_import 'com.jcraft.jsch.SftpATTRS'
  java_import 'com.jcraft.jsch.SftpException'
  java_import 'com.jcraft.jsch.SftpProgressMonitor'
  java_import 'com.jcraft.jsch.SftpStatVFS'
  java_import 'com.jcraft.jsch.Signature'
  java_import 'com.jcraft.jsch.SignatureDSA'
  java_import 'com.jcraft.jsch.SignatureRSA'
  java_import 'com.jcraft.jsch.SocketFactory'
  java_import 'com.jcraft.jsch.UIKeyboardInteractive'
  java_import 'com.jcraft.jsch.UserAuth'
  java_import 'com.jcraft.jsch.UserAuthGSSAPIWithMIC'
  java_import 'com.jcraft.jsch.UserAuthKeyboardInteractive'
  java_import 'com.jcraft.jsch.UserAuthNone'
  java_import 'com.jcraft.jsch.UserAuthPassword'
  java_import 'com.jcraft.jsch.UserAuthPublicKey'
  java_import 'com.jcraft.jsch.UserInfo'
  java_import 'com.jcraft.jsch.Util'

  module JCE
    java_import 'com.jcraft.jsch.jce.AES128CBC'
    java_import 'com.jcraft.jsch.jce.AES128CTR'
    java_import 'com.jcraft.jsch.jce.AES192CBC'
    java_import 'com.jcraft.jsch.jce.AES192CTR'
    java_import 'com.jcraft.jsch.jce.AES256CBC'
    java_import 'com.jcraft.jsch.jce.AES256CTR'
    java_import 'com.jcraft.jsch.jce.ARCFOUR128'
    java_import 'com.jcraft.jsch.jce.ARCFOUR256'
    java_import 'com.jcraft.jsch.jce.ARCFOUR'
    java_import 'com.jcraft.jsch.jce.BlowfishCBC'
    java_import 'com.jcraft.jsch.jce.DH'
    java_import 'com.jcraft.jsch.jce.HMAC'
    java_import 'com.jcraft.jsch.jce.HMACMD596'
    java_import 'com.jcraft.jsch.jce.HMACMD5'
    java_import 'com.jcraft.jsch.jce.HMACSHA196'
    java_import 'com.jcraft.jsch.jce.HMACSHA1'
    java_import 'com.jcraft.jsch.jce.HMACSHA256'
    java_import 'com.jcraft.jsch.jce.HMACSHA512'
    java_import 'com.jcraft.jsch.jce.KeyPairGenDSA'
    java_import 'com.jcraft.jsch.jce.KeyPairGenRSA'
    java_import 'com.jcraft.jsch.jce.MD5'
    java_import 'com.jcraft.jsch.jce.PBKDF'
    java_import 'com.jcraft.jsch.jce.Random'
    java_import 'com.jcraft.jsch.jce.SHA1'
    java_import 'com.jcraft.jsch.jce.SHA256'
    java_import 'com.jcraft.jsch.jce.SignatureDSA'
    java_import 'com.jcraft.jsch.jce.SignatureRSA'
    java_import 'com.jcraft.jsch.jce.TripleDESCBC'
    java_import 'com.jcraft.jsch.jce.TripleDESCTR'
  end

  module JCraft
    java_import 'com.jcraft.jsch.jcraft.HMAC'
    java_import 'com.jcraft.jsch.jcraft.HMACMD596'
    java_import 'com.jcraft.jsch.jcraft.HMACMD5'
    java_import 'com.jcraft.jsch.jcraft.HMACSHA196'
    java_import 'com.jcraft.jsch.jcraft.HMACSHA1'
  end

  module JGSS
    java_import 'com.jcraft.jsch.jgss.GSSContextKrb5'
  end
end
